@echo off
setlocal EnableDelayedExpansion

rem Show a text file that include BBCode tags (version 0.1 - preliminary)
rem Antonio Perez Ayala

if "%~1" neq "" if "%~1" neq "/?" goto begin
echo Show a text file that may include a limited subset of BBCode tags
echo/
echo ShowBBC filename.txt
echo/
echo For a detailed description of this program, type:
echo ShowBBC ShowBBC.txt
goto :EOF

:begin
cd "%~P0"
if not exist %1 echo File not found & goto :EOF

rem Read the file(s) and decode the tags
set /A F=0, NF=1, lines1=0
set "file[1]=%~1"

:parseNextFile
if %F% equ %NF% goto endFiles
set /A F+=1, U=2
set "file=!file[%F%]!"
set "link[%F%]=0 0 2 0  77 0 79 0"
set "url[%F%,1]=call :goBack"
set "url[%F%,2]=goto endShow"
echo Loading "%file%"...
for /F "tokens=1* delims=:" %%i in ('findstr /N "^" "%file%"') do (
   set "line=%%j"
   call :parseTags
   if !C! equ 1 (
      set "line[%F%,%%i]=!line!"
      set "lC[%F%,%%i]=1"
   ) else if defined line (
      set "line[%F%,%%i]=!line:~2,-1!"
   )
   set "L=%%i"
)
set /A L[%F%]=L, U[%F%]=U
if %L% gtr %lines1% set "lines1=%L%"
goto parseNextFile
:endFiles

rem Show the file(s)
set "lines0=" & set "cols0="
for /F "skip=2 tokens=2" %%a in ('mode con') do (
   if not defined lines0 (set "lines0=%%a"
   ) else if not defined cols0 set "cols0=%%a"
)
set /A lines1+=3
mode con cols=80 lines=%lines1%
title ShowBBC.bat  -  %~1
color F0
set "back="
set "F=1"
:showNextFile
cls
echo/
for /L %%i in (1,1,!L[%F%]!) do (
   if "!lC[%F%,%%i]!" equ "1" (
      ColorChar !line[%F%,%%i]! 13 10
   ) else (
      echo/!line[%F%^,%%i]!
   )
)
CursorPos 77 0 & ColorChar /CF " x "
if defined back (set "col=F0") else set "col=F7"
CursorPos 0 0 & ColorChar /%col% "<--" 8 8 8
set "lastF=%F%"
:getInput
GetInput /M !link[%F%]!
set "option=%errorlevel%"
!url[%F%^,%option%]!
if %F% equ %lastF% goto getInput
if %option% neq 1 set "back=%lastF% %back%"
goto showNextFile
:endShow
mode con cols=%cols0% lines=%lines0%
color
cls
goto :EOF

:goBack
if not defined back exit /B
for /F "tokens=1*" %%a in ("%back%") do (
   set "F=%%a"
   set "back=%%b"
)
exit /B


:parseTags
set "C=0"
set "L="
:nextTag
   if not defined line goto endTags
   for /F "tokens=1* delims=[" %%a in ("!line!") do (
      set "L=!L! "%%a""
      set "line=%%b"
   )
   if not defined line goto endTags
   set "C=1"
   if "!line:~0,6!" equ "color=" (
      for /F "tokens=2,3* delims=][" %%a in ("!line!") do (
         set "L=!L! /%line:~6,2% "%%a" /"
         set "line=%%c"
      )
   ) else if "!line:~0,4!" equ "url=" (
      for /F "tokens=1-3* delims=][" %%a in ("!line!") do (
         set "url=%%a"
         set "url=!url:~4!"
         set /A U+=1
         if "!url:~0,4!" equ "http" (
            set url[%F%,!U!]=explorer "!url!"
         ) else if "!url:~0,1!" neq "#" (
            set "url[%F%,!U!]=!url!"
         ) else (
            set /A NF+=1
            set "file[!NF!]=!url:~1!"
            set "url[%F%,!U!]=set F=!NF!"
         )
         set lef=0
         for %%a in (!L!) do (
            call :StrLen %%a
            set /A lef+=!errorlevel!
         )
         call :StrLen "%%b"
         set /A rig=lef+!errorlevel!-1
         set "link[%F%]=!link[%F%]!  !lef! %%i !rig! %%i"
         set "L=!L! /F1 "%%b" /"
         set "line=%%d"
      )
   ) else if "!line:~0,1!" equ "]" (
      set L=!L! "["
      set "line=!line:~1!"
   ) else (
      set L=!L! "["
   )
)
goto nextTag
:endTags
set "line=!L!"
exit /B

:StrLen "str"
set "str=0%~1"
set "len=0"
for /L %%a in (6,-1,0) do (
   set /A "newLen=len+(1<<%%a)"
   for %%b in (!newLen!) do if "!str:~%%b,1!" neq "" set "len=%%b"
)
exit /B %len%
